Subject: bug#46942: ci.guix.gnu.org is slow from my system

From: raid5atemyhomework <[email-masked]>
Date: Fri, 05 Mar 2021 13:00:33 +0000

Hi zimoun,

> Hi,
>
> On Fri, 05 Mar 2021 at 11:22, raid5atemyhomework via Bug reports for GNU Guix [email-masked] wrote:
>
> > This can be very slow, including as slow as 4KiB/s at times.
>
> [...]
>
> > The problem is not on my ISP, or at least not solely on my ISP. Doing a `wget` from `github.com`:
>
> [...]
>
> > As can be seen above, I get 9.34MB/s elsewhere, which is better than the >60Mbit/s promised by my ISP.
>
> Where are you located? I mean,ci.guix.gnu.org is in Berlin, so if you
> are far, say in Alaska or in Puerto Williams[*], you get a poor
> downloading rate. However, github.com probably uses CDN or something
> like that, so obviously the rate becomes much better.
>
> *Puerto Williams, the World Southest town with an Internet
> connection. :-)

I would rather not say, since I am a very private person (otherwise I wouldn't be using the "raid5atemyhomework" moniker).

What I **do** find strange is that ***Tor is faster***.  Surely connecting directly from my ISP to ci.guix.gnu.org should be, in principle, faster than connecting to my ISP to a random node, which connects to another random node, which connects to another random node, which finally connects to Berlin, should be ***slower***?

Here are a few `ping`s to some places:

```
$ ping gnu.org
PING gnu.org (209.51.188.148) 56(84) bytes of data.
64 bytes from wildebeest.gnu.org (209.51.188.148): icmp_seq=1 ttl=50 time=301 ms
64 bytes from wildebeest.gnu.org (209.51.188.148): icmp_seq=2 ttl=50 time=306 ms
64 bytes from wildebeest.gnu.org (209.51.188.148): icmp_seq=3 ttl=50 time=335 ms
64 bytes from wildebeest.gnu.org (209.51.188.148): icmp_seq=4 ttl=50 time=257 ms
64 bytes from wildebeest.gnu.org (209.51.188.148): icmp_seq=5 ttl=50 time=234 ms
^C
--- gnu.org ping statistics ---
5 packets transmitted, 5 received, 0% packet loss, time 4226ms
rtt min/avg/max/mdev = 233.804/286.626/335.242/36.261 ms

$ ping www.vikings.net
PING www.vikings.net (168.119.169.112) 56(84) bytes of data.
64 bytes from v0.h.vkgs.io (168.119.169.112): icmp_seq=1 ttl=48 time=190 ms
64 bytes from v0.h.vkgs.io (168.119.169.112): icmp_seq=2 ttl=48 time=190 ms
64 bytes from v0.h.vkgs.io (168.119.169.112): icmp_seq=3 ttl=48 time=220 ms
64 bytes from v0.h.vkgs.io (168.119.169.112): icmp_seq=4 ttl=48 time=241 ms
64 bytes from v0.h.vkgs.io (168.119.169.112): icmp_seq=5 ttl=48 time=264 ms
^C
--- www.vikings.net ping statistics ---
5 packets transmitted, 5 received, 0% packet loss, time 4413ms
rtt min/avg/max/mdev = 189.767/220.941/264.326/29.054 ms

$ ping www.raptorcs.com
PING www.raptorcs.com (23.155.224.44) 56(84) bytes of data.
64 bytes from websvc.rptsys.com (23.155.224.44): icmp_seq=1 ttl=55 time=294 ms
64 bytes from websvc.rptsys.com (23.155.224.44): icmp_seq=2 ttl=55 time=307 ms
64 bytes from websvc.rptsys.com (23.155.224.44): icmp_seq=3 ttl=55 time=227 ms
^C
--- www.raptorcs.com ping statistics ---
3 packets transmitted, 3 received, 0% packet loss, time 2627ms
rtt min/avg/max/mdev = 226.868/275.933/306.748/35.071 ms
```

And here's a few select `wget`s:

```
$ wget https://store.vikings.net/image/cache/catalog/kcmad8-1088x816.jpeg
--2021-03-05 20:50:37--  https://store.vikings.net/image/cache/catalog/kcmad8-1088x816.jpeg
Resolving store.vikings.net (store.vikings.net)... 185.199.141.17
Connecting to store.vikings.net (store.vikings.net)|185.199.141.17|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 246991 (241K) [image/jpeg]
Saving to: ‘kcmad8-1088x816.jpeg’

kcmad8-1088x816.jpeg                            100%[=====================================================================================================>] 241.20K  19.2KB/s    in 13s

2021-03-05 20:50:51 (19.2 KB/s) - ‘kcmad8-1088x816.jpeg’ saved [246991/246991]

$ torify wget https://store.vikings.net/image/cache/catalog/kcmad8-1088x816.jpeg
--2021-03-05 20:51:22--  https://store.vikings.net/image/cache/catalog/kcmad8-1088x816.jpeg
Resolving store.vikings.net (store.vikings.net)... 185.199.141.17
Connecting to store.vikings.net (store.vikings.net)|185.199.141.17|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 246991 (241K) [image/jpeg]
Saving to: ‘kcmad8-1088x816.jpeg.1’

kcmad8-1088x816.jpeg.1                          100%[=====================================================================================================>] 241.20K   293KB/s    in 0.8s

2021-03-05 20:51:25 (293 KB/s) - ‘kcmad8-1088x816.jpeg.1’ saved [246991/246991]

$ wget https://static.fsf.org/nosvn/videos/fight-to-repair/videos/Fight-to-Repair-720p.webm
--2021-03-05 20:54:03--  https://static.fsf.org/nosvn/videos/fight-to-repair/videos/Fight-to-Repair-720p.webm
Resolving static.fsf.org (static.fsf.org)... 209.51.188.233, 2001:470:142:5::233
Connecting to static.fsf.org (static.fsf.org)|209.51.188.233|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 40191351 (38M) [video/webm]
Saving to: ‘Fight-to-Repair-720p.webm’

Fight-to-Repair-720p.webm                         2%[=>                                                                                                    ] 856.00K   146KB/s    eta 4m 32s ^C

$ torify wget https://static.fsf.org/nosvn/videos/fight-to-repair/videos/Fight-to-Repair-720p.webm
--2021-03-05 20:54:13--  https://static.fsf.org/nosvn/videos/fight-to-repair/videos/Fight-to-Repair-720p.webm
Resolving static.fsf.org (static.fsf.org)... 209.51.188.233
Connecting to static.fsf.org (static.fsf.org)|209.51.188.233|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 40191351 (38M) [video/webm]
Saving to: ‘Fight-to-Repair-720p.webm.1’

Fight-to-Repair-720p.webm.1                       6%[=====>                                                                                                ]   2.55M   498KB/s    eta 92s    ^C

$ wget https://static.raptorcs.com/TL2WK2/images/boardlarge.png
--2021-03-05 20:57:19--  https://static.raptorcs.com/TL2WK2/images/boardlarge.png
Resolving static.raptorcs.com (static.raptorcs.com)... 23.155.224.44
Connecting to static.raptorcs.com (static.raptorcs.com)|23.155.224.44|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 5398922 (5.1M) [image/png]
Saving to: ‘boardlarge.png’

boardlarge.png                                  100%[=====================================================================================================>]   5.15M   505KB/s    in 9.4s

2021-03-05 20:57:30 (559 KB/s) - ‘boardlarge.png’ saved [5398922/5398922]

$ torify wget https://static.raptorcs.com/TL2WK2/images/boardlarge.png
--2021-03-05 20:57:32--  https://static.raptorcs.com/TL2WK2/images/boardlarge.png
Resolving static.raptorcs.com (static.raptorcs.com)... 23.155.224.44
Connecting to static.raptorcs.com (static.raptorcs.com)|23.155.224.44|:443... connected.
HTTP request sent, awaiting response... 200 OK
Length: 5398922 (5.1M) [image/png]
Saving to: ‘boardlarge.png.1’

boardlarge.png.1                                100%[=====================================================================================================>]   5.15M   534KB/s    in 10s

2021-03-05 20:57:45 (515 KB/s) - ‘boardlarge.png.1’ saved [5398922/5398922]

```

I know Vikings is based in Germany, so it looks like my ISP does not like connecting to German sites --- again I am seeing this phenomenon where using Tor is faster than connecting directly, but it certainly now looks a whole lot more like a problem with my ISP.

On the other hand the `fsf.org` site has better speed when connected directly, but still the one via Tor is about 3x faster.

And finally RaptorCS is about the same speed both directly and over Tor.  Again, this is still a surprise as I expect Tor to be slower than direct connection.

Lemme go poke at my ISP.

Thanks
raid5atemyhomework